
# q-expansion of newform 786.2.a.f, downloaded from the LMFDB on 25 April 2024.

# We generate the q-expansion using the Hecke eigenvalues a_p at the primes.
# Each a_p is given as a linear combination
# of the following basis for the coefficient ring.

def make_data():

    from sage.all import prod, floor, prime_powers, gcd, QQ, primes_first_n, next_prime, RR

    def discrete_log(elts, gens, mod):
        # algorithm 2.2, page 16 of https://arxiv.org/abs/0903.2785
        def table_gens(gens, mod):
            T = [1]
            n = len(gens)
            r = [None]*n
            s = [None]*n
            for i in range(n):
                beta = gens[i]
                r[i] = 1
                N = len(T)
                while beta not in T:
                    for Tj in T[:N]:
                        T.append((beta*Tj) % mod)
                    beta = (beta*gens[i]) % mod
                    r[i] += 1
                s[i] = T.index(beta)
            return T, r, s
        T, r, s = table_gens(gens, mod)
        n = len(gens)
        N = [ prod(r[:j]) for j in range(n) ]
        Z = lambda s: [ (floor(s/N[j]) % r[j]) for j in range(n)]
        return [Z(T.index(elt % mod)) for elt in elts]
    def extend_multiplicatively(an):
        for pp in prime_powers(len(an)-1):
            for k in range(1, (len(an) - 1)//pp + 1):
                if gcd(k, pp) == 1:
                    an[pp*k] = an[pp]*an[k]
    from sage.all import PolynomialRing, NumberField
    R = PolynomialRing(QQ, "x")
    f = R(poly_data)
    K = NumberField(f, "a")
    betas = [K.gens()[0]**i for i in range(len(poly_data))]
    convert_elt_to_field = lambda elt: sum(c*beta for c, beta in zip(elt, betas))
    # convert aps to K elements
    primes = primes_first_n(len(aps_data))
    good_primes = [p for p in primes if not p.divides(level)]
    aps = map(convert_elt_to_field, aps_data)
    if not hecke_ring_character_values:
        # trivial character
        char_values = dict(zip(good_primes, [1]*len(good_primes)))
    else:
        gens = [elt[0] for elt in hecke_ring_character_values]
        gens_values = [convert_elt_to_field(elt[1]) for elt in hecke_ring_character_values]
        char_values = dict([(
            p,prod(g**k for g, k in zip(gens_values, elt)))
            for p, elt in zip(good_primes, discrete_log(good_primes, gens, level))
            ])
    an_list_bound = next_prime(primes[-1])
    an = [0]*an_list_bound
    an[1] = 1
    
    from sage.all import PowerSeriesRing
    PS = PowerSeriesRing(K, "q")
    for p, ap in zip(primes, aps):
        if p.divides(level):
            euler_factor = [1, -ap]
        else:
            euler_factor = [1, -ap, p**(weight - 1) * char_values[p]]
        k = RR(an_list_bound).log(p).floor() + 1
        foo = (1/PS(euler_factor)).padded_list(k)
        for i in range(1, k):
            an[p**i] = foo[i]
    extend_multiplicatively(an)
    return PS(an)
level = 786
weight = 2
poly_data = [0, 1]

# The basis for the coefficient ring is just the power basis
# in the root of the defining polynomial above.
hecke_ring_character_values = None
aps_data = [[-1], [1], [-3], [5], [3], [2], [-3], [-4], [-3], [6], [2], [-1], [12], [8], [9], [9], [3], [-10], [-13], [-15], [2], [-4], [6], [6], [-4], [-6], [14], [-12], [-4], [6], [2], [-1], [-9], [-1], [-18], [8], [-1], [-16], [-6], [-12], [-15], [26], [0], [-22], [12], [20], [-10], [14], [-18], [-7], [-18], [0], [26], [6], [-30], [24], [3], [29], [-10], [15], [-22], [-12], [-34], [-12], [-28], [3], [-25], [2], [-18], [11], [36], [21], [17], [-22], [-10], [-6], [-18], [-22], [21], [5], [30], [2], [-30], [-16], [-28], [-24], [-27], [29], [-6], [14], [9], [-15], [23], [-18], [23], [-21], [42], [33], [-7], [26], [-37], [-3], [33], [24], [17], [-34], [-27], [15], [-24], [-43], [-16], [-16], [-42], [-1], [29], [-12], [41], [-30], [6], [15], [41], [20], [0], [15], [-16], [-27], [5], [36], [-28], [14], [-4], [24], [50], [-16], [-30], [17], [12], [32], [-33], [27], [56], [18], [-4], [-12], [-28], [6], [17], [18], [47], [18], [26], [-6], [-4], [-24], [38], [12], [38], [-36], [-19], [18], [6], [24], [-4], [18], [12], [27], [-61], [-28]]
